'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = subscribe;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _racer = require('racer');

var _racer2 = _interopRequireDefault(_racer);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _model2 = require('@react-sharedb/model');

var _model3 = _interopRequireDefault(_model2);

var _Doc = require('./types/Doc');

var _Doc2 = _interopRequireDefault(_Doc);

var _Query = require('./types/Query');

var _Query2 = _interopRequireDefault(_Query);

var _QueryExtra = require('./types/QueryExtra');

var _QueryExtra2 = _interopRequireDefault(_QueryExtra);

var _Local = require('./types/Local');

var _Local2 = _interopRequireDefault(_Local);

var _Batching = require('./Batching');

var _Batching2 = _interopRequireDefault(_Batching);

var _LocalDoc = require('racer/lib/Model/LocalDoc');

var _LocalDoc2 = _interopRequireDefault(_LocalDoc);

var _semaphore = require('./semaphore');

var _semaphore2 = _interopRequireDefault(_semaphore);

var _observerUtil = require('@nx-js/observer-util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_COLLECTION = '$components';
var SUBSCRIBE_COMPUTATION_NAME = '__subscribeComputation';
var HELPER_METHODS_TO_BIND = ['get', 'at'];
var DUMMY_STATE = {};
var batching = new _Batching2.default();

function subscribe(fn) {
  return function decorateTarget(Component) {
    var isStateless = !(Component.prototype && Component.prototype.isReactComponent);
    var AutorunComponent = Component.__isSubscription ? Component : getAutorunComponent(Component, isStateless);
    var SubscriptionsContainer = getSubscriptionsContainer(AutorunComponent, fn ? [fn] : []);
    return (0, _hoistNonReactStatics2.default)(SubscriptionsContainer, AutorunComponent);
  };
}

var getAutorunComponent = function getAutorunComponent(Component, isStateless) {
  return function (_ref) {
    (0, _inherits3.default)(AutorunHOC, _ref);

    function AutorunHOC(props) {
      var _ref2;

      (0, _classCallCheck3.default)(this, AutorunHOC);

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      // TODO: Remove this.scope alias.
      //       Since ComponentWillMount became deprecated
      //       we should not use this.scope alias anymore
      //       and do all the initialization in the constructor
      var _this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = AutorunHOC.__proto__ || (0, _getPrototypeOf2.default)(AutorunHOC)).call.apply(_ref2, [this, props].concat(args)));

      _this.scope = props.scope;

      // Mark subscription as used.
      // This is needed to track in later @subscribe's whether
      // to create a new $scope or use the one received from props
      // (in case when the outer component is @subscribe)
      props.$scope.__used = true;

      // let fn = _.debounce(() => {
      //   if (this.unmounted) return
      //   this.setState(DUMMY_STATE)
      // })

      var updateFn = function updateFn() {
        if (_this.unmounted) return;
        _this.setState(DUMMY_STATE);
      };
      _this.update = function () {
        return batching.add(updateFn);
      };

      // let fn = () => batchedUpdate(() => {
      //   if (this.unmounted) return
      //   this.setState(DUMMY_STATE)
      // })

      // create a reactive render for the component
      // run a dummy setState to schedule a new reactive render, avoid forceUpdate
      _this.render = (0, _observerUtil.observe)(_this.render, {
        scheduler: _this.update,
        lazy: true
      });
      return _this;
    }

    (0, _createClass3.default)(AutorunHOC, [{
      key: 'render',
      value: function render() {
        return isStateless ? Component(this.props, this.context) : (0, _get3.default)(AutorunHOC.prototype.__proto__ || (0, _getPrototypeOf2.default)(AutorunHOC.prototype), 'render', this).call(this);
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.unmounted = true;
        // stop autorun
        (0, _observerUtil.unobserve)(this.render);
        // call user defined componentWillUnmount
        if ((0, _get3.default)(AutorunHOC.prototype.__proto__ || (0, _getPrototypeOf2.default)(AutorunHOC.prototype), 'componentWillUnmount', this)) (0, _get3.default)(AutorunHOC.prototype.__proto__ || (0, _getPrototypeOf2.default)(AutorunHOC.prototype), 'componentWillUnmount', this).call(this);
      }
    }]);
    return AutorunHOC;
  }(isStateless ? _react2.default.Component : Component);
};

var getSubscriptionsContainer = function getSubscriptionsContainer(DecoratedComponent, fns) {
  var _class, _temp;

  return _temp = _class = function (_React$Component) {
    (0, _inherits3.default)(SubscriptionsContainer, _React$Component);

    function SubscriptionsContainer() {
      (0, _classCallCheck3.default)(this, SubscriptionsContainer);
      return (0, _possibleConstructorReturn3.default)(this, (SubscriptionsContainer.__proto__ || (0, _getPrototypeOf2.default)(SubscriptionsContainer)).apply(this, arguments));
    }

    (0, _createClass3.default)(SubscriptionsContainer, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.model = this.getOrCreateModel();
        this.models = {};
        // pipe the local model into props as $scope
        this.models.$scope = this.model;
        this.scope = this.model.get();
        this.autorunSubscriptions();
      }

      // TODO: Implement queueing

    }, {
      key: 'componentWillReceiveProps',
      value: function () {
        var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
          for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }

          var nextProps, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, dataFn;

          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  nextProps = args[0];
                  _iteratorNormalCompletion = true;
                  _didIteratorError = false;
                  _iteratorError = undefined;
                  _context.prev = 4;
                  _iterator = (0, _getIterator3.default)(this.dataFns);

                case 6:
                  if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                    _context.next = 16;
                    break;
                  }

                  dataFn = _step.value;
                  _context.next = 10;
                  return dataFn(nextProps);

                case 10:
                  if (!this.unmounted) {
                    _context.next = 12;
                    break;
                  }

                  return _context.abrupt('return');

                case 12:
                  if (this.doForceUpdate) {
                    this.doForceUpdate = false;
                    this.setState(DUMMY_STATE);
                  }

                case 13:
                  _iteratorNormalCompletion = true;
                  _context.next = 6;
                  break;

                case 16:
                  _context.next = 22;
                  break;

                case 18:
                  _context.prev = 18;
                  _context.t0 = _context['catch'](4);
                  _didIteratorError = true;
                  _iteratorError = _context.t0;

                case 22:
                  _context.prev = 22;
                  _context.prev = 23;

                  if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                  }

                case 25:
                  _context.prev = 25;

                  if (!_didIteratorError) {
                    _context.next = 28;
                    break;
                  }

                  throw _iteratorError;

                case 28:
                  return _context.finish(25);

                case 29:
                  return _context.finish(22);

                case 30:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this, [[4, 18, 22, 30], [23,, 25, 29]]);
        }));

        function componentWillReceiveProps() {
          return _ref3.apply(this, arguments);
        }

        return componentWillReceiveProps;
      }()

      // TODO: Maybe throw an error when passing used $scope to new @subscribe

    }, {
      key: 'getOrCreateModel',
      value: function getOrCreateModel() {
        if (this.props.$scope && !this.props.$scope.__used) {
          return this.props.$scope;
        } else {
          var _model = generateScopedModel();
          _semaphore2.default.allowComponentSetter = true;
          _model.set('', (0, _observerUtil.observable)({})); // Initially set empty object for observable
          _semaphore2.default.allowComponentSetter = false;
          bindMethods(_model, HELPER_METHODS_TO_BIND);
          return _model;
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.unmounted = true;

        // Stop all subscription params computations
        for (var index = 0; index < this.dataFns.length; index++) {
          var computationName = getComputationName(index);
          this.comps[computationName] && (0, _observerUtil.unobserve)(this.comps[computationName]);
          delete this.comps[computationName];
        }
        delete this.dataFns;

        // Destroy whole model before destroying items one by one.
        // This prevents model.on() and model.start() from firing
        // extra times
        _semaphore2.default.allowComponentSetter = true;
        this.model.destroy();
        _semaphore2.default.allowComponentSetter = false;

        // Destroy all subscription items
        for (var key in this.items) {
          this.destroyItem(key, true, true);
        }

        delete this.models.$scope;
        delete this.models;
        delete this.scope;
        delete this.model; // delete the actual model
      }
    }, {
      key: 'render',
      value: function render() {
        var _this3 = this;

        this.rendered = true;
        if (this.loaded) {
          return _react2.default.createElement(DecoratedComponent, (0, _extends3.default)({}, this.props, {
            scope: this.scope
          }, this.models, {
            ref: function ref() {
              if (!DecoratedComponent.__isSubscription) {
                var _props;

                if (_this3.props.innerRef) (_props = _this3.props).innerRef.apply(_props, arguments);
              }
            }
          }));
        } else {
          // When in React Native env, don't use any loading spinner
          if (typeof navigator !== 'undefined' && navigator.product === 'ReactNative') {
            return null;
          } else {
            return _react2.default.createElement('div', { className: 'Loading' });
          }
        }
      }

      // TODO: When we change subscription params quickly, we are going to
      //       receive a race condition when earlier subscription result might
      //       take longer to process compared to the same newer subscription.
      //       Implement Queue.

    }, {
      key: 'autorunSubscriptions',
      value: function () {
        var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
          var _this4 = this;

          var _loop, index, _ret;

          return _regenerator2.default.wrap(function _callee3$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  this.items = {};
                  this.comps = {};
                  this.dataFns = [];
                  _loop = /*#__PURE__*/_regenerator2.default.mark(function _loop(index) {
                    var fn, subscriptions, dataFn;
                    return _regenerator2.default.wrap(function _loop$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            fn = fns[index];
                            subscriptions = {};

                            dataFn = function () {
                              var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(props) {
                                var prevSubscriptions, computationName, subscribeFn, keys, promises, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, key;

                                return _regenerator2.default.wrap(function _callee2$(_context2) {
                                  while (1) {
                                    switch (_context2.prev = _context2.next) {
                                      case 0:
                                        if (_this4.model.get()) {
                                          _context2.next = 2;
                                          break;
                                        }

                                        return _context2.abrupt('return');

                                      case 2:
                                        prevSubscriptions = subscriptions || {};
                                        computationName = getComputationName(index);

                                        subscribeFn = function subscribeFn() {
                                          subscriptions = fn.call(_this4, typeof props === 'function' ? _this4.props : props);
                                        };

                                        _this4.comps[computationName] && (0, _observerUtil.unobserve)(_this4.comps[computationName]);
                                        _this4.comps[computationName] = (0, _observerUtil.observe)(subscribeFn, {
                                          scheduler: dataFn
                                        });

                                        keys = _lodash2.default.union(_lodash2.default.keys(prevSubscriptions), _lodash2.default.keys(subscriptions));

                                        keys = _lodash2.default.uniq(keys);
                                        promises = [];
                                        _iteratorNormalCompletion2 = true;
                                        _didIteratorError2 = false;
                                        _iteratorError2 = undefined;
                                        _context2.prev = 13;
                                        _iterator2 = (0, _getIterator3.default)(keys);

                                      case 15:
                                        if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                                          _context2.next = 30;
                                          break;
                                        }

                                        key = _step2.value;

                                        if (_lodash2.default.isEqual(subscriptions[key], prevSubscriptions[key])) {
                                          _context2.next = 27;
                                          break;
                                        }

                                        if (!subscriptions[key]) {
                                          _context2.next = 26;
                                          break;
                                        }

                                        _context2.t0 = promises;
                                        _context2.next = 22;
                                        return _this4.initItem(key, subscriptions[key]);

                                      case 22:
                                        _context2.t1 = _context2.sent;

                                        _context2.t0.push.call(_context2.t0, _context2.t1);

                                        _context2.next = 27;
                                        break;

                                      case 26:
                                        _this4.destroyItem(key, true);

                                      case 27:
                                        _iteratorNormalCompletion2 = true;
                                        _context2.next = 15;
                                        break;

                                      case 30:
                                        _context2.next = 36;
                                        break;

                                      case 32:
                                        _context2.prev = 32;
                                        _context2.t2 = _context2['catch'](13);
                                        _didIteratorError2 = true;
                                        _iteratorError2 = _context2.t2;

                                      case 36:
                                        _context2.prev = 36;
                                        _context2.prev = 37;

                                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                          _iterator2.return();
                                        }

                                      case 39:
                                        _context2.prev = 39;

                                        if (!_didIteratorError2) {
                                          _context2.next = 42;
                                          break;
                                        }

                                        throw _iteratorError2;

                                      case 42:
                                        return _context2.finish(39);

                                      case 43:
                                        return _context2.finish(36);

                                      case 44:
                                        _context2.next = 46;
                                        return _promise2.default.all(promises);

                                      case 46:
                                      case 'end':
                                        return _context2.stop();
                                    }
                                  }
                                }, _callee2, _this4, [[13, 32, 36, 44], [37,, 39, 43]]);
                              }));

                              return function dataFn(_x) {
                                return _ref5.apply(this, arguments);
                              };
                            }();

                            _this4.dataFns.push(dataFn);
                            _context3.next = 6;
                            return dataFn(_this4.props);

                          case 6:
                            if (!_this4.unmounted) {
                              _context3.next = 8;
                              break;
                            }

                            return _context3.abrupt('return', {
                              v: void 0
                            });

                          case 8:
                          case 'end':
                            return _context3.stop();
                        }
                      }
                    }, _loop, _this4);
                  });
                  index = 0;

                case 5:
                  if (!(index < fns.length)) {
                    _context4.next = 13;
                    break;
                  }

                  return _context4.delegateYield(_loop(index), 't0', 7);

                case 7:
                  _ret = _context4.t0;

                  if (!((typeof _ret === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret)) === "object")) {
                    _context4.next = 10;
                    break;
                  }

                  return _context4.abrupt('return', _ret.v);

                case 10:
                  index++;
                  _context4.next = 5;
                  break;

                case 13:
                  // Reset force update since we are doing the initial rendering anyways
                  this.doForceUpdate = false;
                  this.loaded = true;
                  // Sometimes all the subscriptions might go through synchronously
                  // (for example if we are only subscribing to local data).
                  // In this case we don't need to manually trigger update
                  // since render will execute on its own later in the lifecycle.
                  if (this.rendered) this.setState(DUMMY_STATE);

                case 16:
                case 'end':
                  return _context4.stop();
              }
            }
          }, _callee3, this);
        }));

        function autorunSubscriptions() {
          return _ref4.apply(this, arguments);
        }

        return autorunSubscriptions;
      }()

      // TODO: Maybe implement queueing. Research if race condition is present.

    }, {
      key: 'initItem',
      value: function () {
        var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(key, params) {
          var _this5 = this;

          var constructor, item;
          return _regenerator2.default.wrap(function _callee4$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  constructor = getItemConstructor(params);
                  item = new constructor(this.model, key, params);
                  _context5.next = 4;
                  return item.init();

                case 4:
                  if (!this.unmounted) {
                    _context5.next = 6;
                    break;
                  }

                  return _context5.abrupt('return', item.destroy());

                case 6:
                  batching.batch(function () {
                    if (_this5.items[key]) _this5.destroyItem(key);
                    item.refModel();
                    _this5.items[key] = item;
                    // Expose scoped model under the same name with prepended $
                    var keyModelName = getScopedModelName(key);
                    if (!_this5.models[keyModelName]) {
                      _this5.models[keyModelName] = _this5.model.at(key);
                      _this5.doForceUpdate = true;
                    }
                  });

                case 7:
                case 'end':
                  return _context5.stop();
              }
            }
          }, _callee4, this);
        }));

        function initItem(_x2, _x3) {
          return _ref6.apply(this, arguments);
        }

        return initItem;
      }()

      // TODO: Refactor to use 3 different facade methods

    }, {
      key: 'destroyItem',
      value: function destroyItem(key, terminate, modelDestroyed) {
        var _this6 = this;

        if (!this.items[key]) return console.error('Trying to destroy', key);
        batching.batch(function () {
          if (!modelDestroyed) _this6.items[key].unrefModel();
          var keyModelName = getScopedModelName(key);
          if (terminate) {
            delete _this6[keyModelName];
            _this6.doForceUpdate = true;
          }
          _this6.items[key].destroy();
        });
        delete this.items[key];
      }
    }]);
    return SubscriptionsContainer;
  }(_react2.default.Component), _class.__isSubscription = true, _temp;
};

function generateScopedModel() {
  var path = DEFAULT_COLLECTION + '.' + _model3.default.id();
  return _model3.default.scope(path);
}

function isExtraQuery(queryParams) {
  return queryParams.$count || queryParams.$aggregate;
}

function getItemConstructor(subscription) {
  if (typeof subscription === 'string') return _Local2.default;

  var _subscription = (0, _slicedToArray3.default)(subscription, 2),
      params = _subscription[1];

  return typeof params === 'string' || !params ? _Doc2.default : isExtraQuery(params) ? _QueryExtra2.default : _Query2.default;
}

function getComputationName(index) {
  return '' + SUBSCRIBE_COMPUTATION_NAME + index;
}

function bindMethods(object, methodsToBind) {
  var _iteratorNormalCompletion3 = true;
  var _didIteratorError3 = false;
  var _iteratorError3 = undefined;

  try {
    for (var _iterator3 = (0, _getIterator3.default)(methodsToBind), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
      var method = _step3.value;

      object[method] = object[method].bind(object);
    }
  } catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion3 && _iterator3.return) {
        _iterator3.return();
      }
    } finally {
      if (_didIteratorError3) {
        throw _iteratorError3;
      }
    }
  }
}

function getScopedModelName(key) {
  return '$' + key;
}

var BATCH_SETTERS = ['_mutate', '_setEach', '_setDiff', '_setDiffDeep'];

var _iteratorNormalCompletion4 = true;
var _didIteratorError4 = false;
var _iteratorError4 = undefined;

try {
  var _loop2 = function _loop2() {
    var methodName = _step4.value;

    var oldMethod = _racer2.default.Model.prototype[methodName];
    _racer2.default.Model.prototype[methodName] = function () {
      var _this7 = this,
          _arguments = arguments;

      var value = void 0;
      batching.batch(function () {
        value = oldMethod.apply(_this7, _arguments);
      });
      return value;
    };
  };

  for (var _iterator4 = (0, _getIterator3.default)(BATCH_SETTERS), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
    _loop2();
  }
} catch (err) {
  _didIteratorError4 = true;
  _iteratorError4 = err;
} finally {
  try {
    if (!_iteratorNormalCompletion4 && _iterator4.return) {
      _iterator4.return();
    }
  } finally {
    if (_didIteratorError4) {
      throw _iteratorError4;
    }
  }
}

var WARNING_SETTERS = ['_set', '_setDiff', '_setNull', '_del'];
var _iteratorNormalCompletion5 = true;
var _didIteratorError5 = false;
var _iteratorError5 = undefined;

try {
  var _loop3 = function _loop3() {
    var methodName = _step5.value;

    var oldMethod = _racer2.default.Model.prototype[methodName];
    _racer2.default.Model.prototype[methodName] = function (segments) {
      if (segments.length === 2 && segments[0] === DEFAULT_COLLECTION && !_semaphore2.default.allowComponentSetter) {
        throw new Error('You can\'t use \'' + methodName.replace(/^_/, '') + '\' on component\'s ' + '$scope root path. Use \'setEach\' instead.');
      }
      return oldMethod.apply(this, arguments);
    };
  };

  for (var _iterator5 = (0, _getIterator3.default)(WARNING_SETTERS), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
    _loop3();
  }

  // Monkey patch racer's local documents to be observable
} catch (err) {
  _didIteratorError5 = true;
  _iteratorError5 = err;
} finally {
  try {
    if (!_iteratorNormalCompletion5 && _iterator5.return) {
      _iterator5.return();
    }
  } finally {
    if (_didIteratorError5) {
      throw _iteratorError5;
    }
  }
}

var oldUpdateCollectionData = _LocalDoc2.default.prototype._updateCollectionData;
_LocalDoc2.default.prototype._updateCollectionData = function () {
  this.data = (0, _observerUtil.observable)(this.data);
  return oldUpdateCollectionData.apply(this, arguments);
};
module.exports = exports['default'];